/* Cyclops
 * FER - SPVP
 * Fakultet elektrotehnike i racunarstva (http://www.fer.hr/)
 * Unska 3, 10000 Zagreb, Hrvatska
 * (c) 2001 FER, Zagreb.
 */

/*!
\file cyclops.c
\brief Dijkstrin algoritam.

Program bi trebao tono raditi svoj posao, za neke druge primjene, osim
taenja optimalnog puta nisam sasvim siguran, ali uvijek se moe probati.
Sretno sa koritenjem, trebat e vam!

\author Zvonko Kostanjar
*/

#include <stdio.h>
#include <string.h>

/* Funkcija koja obavlja zapravo cijeli posao. Ulazni argumenti su poetni
vor, odredini vor, pokaziva na matricu udaljenosti te ukupni broj
vorova */

int *opt_put (int polaziste, int odrediste, int *p, int ukupno) {

  //Inicijalizacija varijabli

  int i,j=0,br=1,udaljenost,pozicija,*S,*T,*Tpom,*put,
    *put_pom,opt_udalj,opt_cvor;

  /**********************************************************************/
  // Odavde pa nadalje -> bez komentara, kog vraga e ti to? Samo
  // poveava broj linija programa, odustajem!
  // Uivaj!!!

  S=(int*)malloc(2*sizeof(int));
  T=(int*)malloc(2*(ukupno-1)*sizeof(int));

  *S=polaziste;
  *(S+1)=0;

  for (i=1;i<=ukupno;i++)
    if (i!=polaziste) {
      *(T+2*j)=i;
      *(T+2*j+1)=*(p+(polaziste-1)*ukupno+i-1);
      j++;
    }

  pozicija= ukupno-1;

  while (pozicija>1) {
    j=0;
    opt_udalj=101;

    for (i=1;i<=pozicija;i++)
      if (*(T+2*(i-1)+1)<opt_udalj) {
	opt_udalj=*(T+2*(i-1)+1);
	opt_cvor=*(T+2*(i-1));
      }

    S=(int*)realloc(S,2*(ukupno-pozicija+1)*sizeof(int));
    *(S+2*(ukupno-pozicija))=opt_cvor;
    *(S+2*(ukupno-pozicija)+1)=opt_udalj;
    Tpom=(int*)malloc(2*(pozicija-1)*sizeof(int));

    for (i=1;i<=pozicija;i++)
      if (*(T+2*(i-1))!=opt_cvor) {
	*(Tpom+2*j)=*(T+2*(i-1));
	*(Tpom+2*j+1)=*(T+2*(i-1)+1);
	j++;
      }

    free(T);
    T=(int*)malloc(2*(pozicija-1)*sizeof(int));

    for (i=1;i<pozicija;i++) {
      *(T+2*(i-1))=*(Tpom+2*(i-1));
      if (*(Tpom+2*(i-1)+1)>(opt_udalj+ *(p+(opt_cvor-1)*ukupno+ *(T+2*(i-1))-1)))
	*(T+2*(i-1)+1)= opt_udalj+ *(p+(opt_cvor-1)*ukupno+ *(T+2*(i-1))-1);

      else  *(T+2*(i-1)+1)= *(Tpom+2*(i-1)+1);

    }

    free(Tpom);
    pozicija--;
  }

  S=(int*)realloc(S,2*ukupno*sizeof(int));
  *(S+2*(ukupno-1))= *T;
  *(S+2*(ukupno-1)+1)= *(T+1);
  free(T);

  put_pom= (int*)malloc(1*sizeof(int));

  j=1;
  while (*(S+2*(j-1))!=odrediste)
    j++;
  udaljenost= *(S+2*(j-1)+1);

  *put_pom=odrediste;

  while (*(S+2*(j-1))!=polaziste) {
    put_pom= (int*)realloc(put_pom,(br+1)*sizeof(int));

    i=1;
    while (*(S+2*(j-1)+1) - *(S+2*(i-1)+1) != *(p + (*(S+2*(i-1))-1)*ukupno+ *(S+2*(j-1))-1))
      i++;
    *(put_pom+br)=*(S+2*(i-1));
    j=i;
    br++;
  }

  put= (int*)malloc((br+1)*sizeof(int));
  *put= udaljenost;
  for (i=1;i<=br;i++)
    *(put+i)=*(put_pom+br-i);

  free(put_pom);
  free(S);
  return put;

  // No pa nije bilo tako tesko, jo malo i gotovo
  // Jole kae sve su ene lijepe, miriu kad vole
  // Miriso bi ja to
  // Od SaDa NaDaLjE sAmO DoBrI kOmEnTaRi
 
}

// Glavni program - uglavnom poziva samo funkciju gore opisanu

void main () {
 
  int ukupno,poc,kon,i=1,*pkon,k,j,*pom;

  printf("\n\n");
  printf ("		Cyclops simulator - Dobro doli\n");
  printf("\n\n");
  printf ("Ugodno je vjerovati u ispravnost svojih misli i pokreta.\n");
  printf ("Uzimati sebe kao mjerilo svih stvari. Prezirati sve strano\n");
  printf ("i od nas razliito. Ali bez duboke sumnje koja saie mozak\n");
  printf ("i isuuje grlo, ostajemo tek samozadovoljne nitice. Neka\n");
  printf ("je blaena misao od koje bjeimo.\n\n");
  printf ("***************************************************************\n\n");

  printf ("Unesite broj vorova:");
  scanf("%d",&ukupno);

  pom=(int*)malloc(ukupno*ukupno*sizeof(int));
  printf("\n");
  printf("Unesite topologiju mree:\n");
  for(j=1;j<=ukupno;j++)
    for(k=1;k<=ukupno;k++) {
      printf("\n");
      printf("Unesite kapacitet izmeu %d i %d:",j,k);
      scanf("%d",pom+(j-1)*ukupno+k-1);
    }

  printf("\n");
  printf ("Unesite polazini vor:");
  scanf("%d",&poc);

  printf("\n");
  printf("Unesite odredini vor:");
  scanf("%d",&kon);

  pkon=opt_put(poc,kon,pom,ukupno);

  printf("\n");
  printf ("***************************************************************\n\n");

  printf("Minimalna udaljenost je:%d\n", *pkon);
  printf("Cvorista preko kojih treba ici su:");

  while (*(pkon+i)!=kon) {
    printf("%d,",*(pkon+i));
    i++;
  }
  printf("%d\n",*(pkon+i));

  free(pom);
  free(pkon);

  // Bravo doao si do kraja, izdrao si, fakat si faca, skoro ko Jole
}
